﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Services.Hive.Common.ServiceContracts;
using HeuristicLab.Clients.Hive.Properties;

namespace HeuristicLab.Clients.Hive {
  internal class ServiceLocator {
    private static ServiceLocator instance = null;
    private ServiceClientFactory<IHiveService> serviceFactory = null;

    public static ServiceLocator Instance {
      get {
        if (instance == null) {
          instance = new ServiceLocator();
        }
        return instance;
      }
    }

    public ServiceLocator() {
      Settings.Default.SettingChanging += new System.Configuration.SettingChangingEventHandler(Default_SettingChanging);
    }

    private void Default_SettingChanging(object sender, System.Configuration.SettingChangingEventArgs e) {
      if (serviceFactory != null) {
        serviceFactory.Username = Settings.Default.HiveUsername;
        serviceFactory.Password = Settings.Default.HivePassword;
      }
    }

    public ServiceClientFactory<IHiveService> ServicePool {
      get {
        if (serviceFactory == null) {
          serviceFactory = new ServiceClientFactory<IHiveService>(Settings.Default.HiveUsername, Settings.Default.HivePassword, "TcpEndpoint");
        }
        return serviceFactory;
      }
    }
  }
}
