﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using HeuristicLab.Common;

namespace HeuristicLab.Services.Hive.Common.DataTransfer {
  [DataContract]
  public abstract class HiveItem : IDeepCloneable {
    [DataMember]
    public Guid Id { get; set; }

    public virtual IDeepCloneable Clone(Cloner cloner) {
      HiveItem clone = (HiveItem)Activator.CreateInstance(this.GetType(), true);
      cloner.RegisterClonedObject(this, clone);
      clone.Id = this.Id;
      return clone;
    }

    public object Clone() {
      return Clone(new Cloner());
    }
  }
}
