﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using System.Data.Linq;
using System.Linq;
using DT = HeuristicLab.Services.Hive.Common.DataTransfer;

namespace HeuristicLab.Services.Hive.DataAccess {
  public static class Convert {

   
    #region Job
    public static DT.Job ToDto(Job source) {
      if (source == null) return null;
      return new DT.Job { Id = source.JobId };// todo
    }
    public static Job ToEntity(DT.Job source) {
      if (source == null) return null;
      return new Job { JobId = source.Id };// todo
    }
    public static void ToEntity(DT.Job source, Job target) {
      if ((source != null) && (target != null)) {
        target.JobId = source.Id;// todo
      }
    }
    #endregion

    #region JobData
    public static DT.JobData ToDto(JobData source) {
      if (source == null) return null;
      return new DT.JobData { JobId = source.JobId };// todo
    }
    public static JobData ToEntity(DT.JobData source) {
      if (source == null) return null;
      return new JobData { JobId = source.Id };// todo
    }
    public static void ToEntity(DT.JobData source, JobData target) {
      if ((source != null) && (target != null)) {
        target.JobId = source.Id;// todo
      }
    }
    #endregion
    
    #region HiveExperiment
    public static DT.HiveExperiment ToDto(HiveExperiment source) {
      if (source == null) return null;
      return new DT.HiveExperiment { Id = source.HiveExperimentId };// todo
    }
    public static HiveExperiment ToEntity(DT.HiveExperiment source) {
      if (source == null) return null;
      return new HiveExperiment { HiveExperimentId = source.Id };// todo
    }
    public static void ToEntity(DT.HiveExperiment source, HiveExperiment target) {
      if ((source != null) && (target != null)) {
        target.HiveExperimentId = source.Id;// todo
      }
    }
    #endregion

    #region Slave
    public static DT.Slave ToDto(Slave source) {
      if (source == null) return null;
      return new DT.Slave { Id = source.ResourceId };// todo
    }
    public static Slave ToEntity(DT.Slave source) {
      if (source == null) return null;
      return new Slave { ResourceId = source.Id };// todo
    }
    public static void ToEntity(DT.Slave source, Slave target) {
      if ((source != null) && (target != null)) {
        target.ResourceId = source.Id;// todo
      }
    }
    #endregion

    #region SlaveGroup
    public static DT.SlaveGroup ToDto(SlaveGroup source) {
      if (source == null) return null;
      return new DT.SlaveGroup { Id = source.ResourceId };// todo
    }
    public static SlaveGroup ToEntity(DT.SlaveGroup source) {
      if (source == null) return null;
      return new SlaveGroup { ResourceId = source.Id };// todo
    }
    public static void ToEntity(DT.SlaveGroup source, SlaveGroup target) {
      if ((source != null) && (target != null)) {
        target.ResourceId = source.Id;// todo
      }
    }
    #endregion

    #region Resource
    public static DT.Resource ToDto(Resource source) {
      if (source == null) return null;
      return new DT.Resource { Id = source.ResourceId };// todo
    }
    public static Resource ToEntity(DT.Resource source) {
      if (source == null) return null;
      return new Resource { ResourceId = source.Id };// todo
    }
    public static void ToEntity(DT.Resource source, Resource target) {
      if ((source != null) && (target != null)) {
        target.ResourceId = source.Id;// todo
      }
    }
    #endregion
  }
}
